#include <stdio.h>
#include <bios.h>
#include <stdlib.h>
#include <time.h>
  
int roomx[26], roomy[26], numobj[26], objchar[26][10], objx[26][10];
int objy[26][10], objcol[26][10], roomtext[26][100], roomchar[26], roomcol[26];

int doorchar[26][4], numdoors[26], doorx[26][4], doory[26][4]; 
int doorexit[26][4], doortype[26][4], newx[26][4], newy[26][4];
char doortext[26][4][36];

int nummons[26], monchar[14], mhealth[26][18], mattack[14];
int mdefense[14], mcol[14], montype[26][18], monexp[14], monitem[26][18];
float monx[26][18], mony[26][18], oldmx[26][18], oldmy[26][18], mspeed[14];
char montext[14][21];

int healthm[14];

int herox=20, heroy=15, oldx=20, oldy=15, health=30, maxhealth=30, numinv=0;
int exp=0, gold=0, attack=2, defense=4, inv[3][21];
int attbon=1, armbon=0, shebon=0;

int numitm[26], itmx[26][10], itmy[26][10], itmchar[21], itmtype[26][10];
int itmbonus[21], itmclass[21], itmcol[21];
char itmtext[21][31], *weapon="dagger", *armour="cloth", *shield="nothing";

FILE *fp, *fopen();

int room = 10, key = 0, textline = 5, clrlines = 5, newroom = 1, wingame = 0;
int mult = 0;

float timelow = 0, timehigh = 0;

main()
{
   int x, y, z;
   
   fp = fopen("room.dat", "r");
   for(x = 1; x < 26; x++)
   {   
      fscanf(fp, "%d %d %d %x %d", &roomx[x], &roomy[x], &roomchar[x],
         &roomcol[x], &numobj[x]);
      for(y = 1; y <= numobj[x]; y++)
      {
         fscanf(fp, "%d %d %d %x", &objchar[x][y], &objx[x][y],
            &objy[x][y], &objcol[x][y]);
      }
   }
   fclose(fp);
   
   fp = fopen("door.dat", "r");
   for(x = 1; x < 26; x++)
   {   
      fscanf(fp, "%d", &numdoors[x]);
      for(y = 1; y <= numdoors[x]; y++)
      {   
         fscanf(fp, "%d %d %d %d %d %d %d ", &doorchar[x][y], &doorx[x][y],
            &doory[x][y], &doorexit[x][y], &doortype[x][y], &newx[x][y],
            &newy[x][y]);
         fgets(doortext[x][y], 35, fp);
      }
   }
   fclose(fp);
   
   fp = fopen("monster.dat", "r");
   for(x = 1; x < 26; x++)
   {   
      fscanf(fp, "%d", &nummons[x]);
      for(y = 1; y <= nummons[x]; y++)
      {
         fscanf(fp, "%f %f %d %d", &monx[x][y], &mony[x][y], &montype[x][y],
            &monitem[x][y]);
         oldmx[x][y] = monx[x][y]; oldmy[x][y] = mony[x][y];
      }
   }
   fclose(fp);
      
   fp = fopen("montable.dat", "r");
   for(x = 1; x < 14; x++)
   {   
      fscanf(fp, "%d %d %d %d %f %x %d ", &monchar[x], &healthm[x],
         &mattack[x], &mdefense[x], &mspeed[x], &mcol[x], &monexp[x]);
      fgets(montext[x], 20, fp);
   }
   fclose(fp);

   for(x = 1; x < 26; x++)
      for(y = 1; y <= nummons[x]; y++)
         mhealth[x][y] = healthm[montype[x][y]];
      
   fp = fopen("item.dat", "r");
   for(x = 1; x < 26; x++)
   {   
      fscanf(fp, "%d", &numitm[x]);
      for(y = 1; y <= numitm[x]; y++)
         fscanf(fp, "%d %d %d", &itmx[x][y], &itmy[x][y], &itmtype[x][y]);
   }
   fclose(fp);
      
   fp = fopen("itmtable.dat", "r");
   for(x = 1; x < 21; x++)
   {   
      fscanf(fp, "%d %x %d %d ", &itmclass[x], 
         &itmcol[x], &itmchar[x], &itmbonus[x]);
      fgets(itmtext[x], 30, fp);
   }
   fclose(fp);
   
   for(x = 1; x < 21; x++)
      inv[1][x] = 0;
   
   cursoff();
   
   cls(0, 0, 80, 50);
   
   poscurs(15, 25);
   printf("%c[1m%c[37mTHE CASTLE OF THE FIRE WITCH", 27, 27);
   poscurs(16, 25);
   printf("%c[0m%c[31m~~~~~~~~~~~~~~~~~~~~~~~~~~~~", 27, 27);
   poscurs(18, 25);
   printf("%c[37mSelect skill level:", 27);
   poscurs(20, 25);
   printf("1. Don't hurt me!");
   poscurs(21, 25);
   printf("2. I think I'm tough");
   poscurs(22, 25);
   printf("3. I eat zombies for breakfast!");
   poscurs(23, 25);
   printf("4. I'm immortal!!");
   poscurs(25, 25);
   printf("5. Too scared to play (quit)");
   poscurs(45, 0);
   printf("   Mark Bliss, Steven Gulka, and Dave Purnell.  (c) 1996 HomeGrown Software");

   while(key < 49 || key > 53)
      key = getkey();

   switch(key)
   {
      case 49:
         mult = 10;
         break;
      case 50:
         mult = 25;
         break;
      case 51:
         mult = 40;
         break;
      case 52:
         mult = 55;
         break;
      case 53:
         key = 27;
   }
   
   cls(0, 0, 80, 50);
   
   poscurs(0, 0);
   writechs(' ', 0x10, 79);
   poscurs(1, 0);
   writechs(' ', 0x10, 79);
   poscurs(2, 0);
   writechs(' ', 0x10, 79);

   poscurs(4, 0);
   writechs(223, 0x06, 38);
   poscurs(45, 0);
   writechs(220, 0x06, 38);
   
   poscurs(47, 0);      
   printf("%c[1m%c[7m%c[33m%c[44m    <F1> - Inventory    <F2> - Drop item    <F3> - Use item    <F4> - Legend    ", 27, 27, 27, 27);

   for(y = 5; y < 45; y++)
   {
      poscurs(y, 0);
      writechs(221, 0x06, 1);
      poscurs(y, 37);
      writechs(222, 0x06, 1);
   }

   while(key != 27 && health > 0 && wingame == 0)
   {
      timehigh = (float)clock()/CLK_TCK;
      key = getkey();
      movehero();

      if(newroom)
         drawroom();

      if(timehigh - timelow > .3)
      {   
         movemon();
         key = 0;
         timelow = timehigh;
      }
      drawstuff();
      oldx = herox; oldy = heroy;
      
      poscurs(0, 2);
      printf("%c[1m%c[7m%c[33m%c[44mHealth: %d/%d ", 27, 27, 27, 27, health,
         maxhealth);
      poscurs(0, 19);
      printf("Experience: %d", exp);
      poscurs(0, 38);
      printf("Attack: %d ", attack + attbon);
      poscurs(0, 52);
      printf("Defense: %d ", defense + armbon + shebon);
      poscurs(0, 67);
      printf("Gold: %d ", gold);
      poscurs(2, 4);
      printf("Weapon: %s  ", weapon);
      poscurs(2, 30);
      printf("Armour: %s  ", armour);
      poscurs(2, 55);
      printf("Shield: %s  ", shield);
      rsttxt();
      if(exp - mult > 0)
      {
         attack += 2;
         defense += 2;
         maxhealth += 5;
         health += 5;
         mult += mult;
      }
   }

   if(key == 27)
   {
      rsttxt();
      cls(0, 0, 80, 50);
      poscurs(24, 23);
      printf("YOU'RE EVEN WIMPER THAN I THOUGHT!");
      sleep(4);
   }
   if(health <= 0)
   {
      cls(39, 4, 80, 45);
      poscurs(24, 48);
      printf("YOU'RE DEAD!  YOU LOSE!!");
      sleep(4);
   }
   if(wingame)
   {   
      cls(39, 4, 80, 45);
      poscurs(24, 55);
      printf("YOU WIN!");
      sleep(4);
   }
   poscurs(48, 0);

   curson();
}

drawroom()
{   
   int i, rnd, rndmon = 0, x, y, notalone = 1;

   cls(39, 4, 80, 45);

   poscurs((46 - roomy[room]) / 2 + 1, (118 - roomx[room]) / 2 + 1);
   writechs(250, 0x74, roomx[room]);
   poscurs(roomy[room] + (46 - roomy[room]) / 2, (118 - roomx[room]) / 2 + 1);
   writechs(250, 0x74, roomx[room]);
   
   for(i = 2; i <= roomy[room] - 1; i++)
   {
      poscurs(i + (46 - roomy[room]) / 2, (118 - roomx[room]) / 2 + 1);
      writechs(250, 0x74, 1);
      poscurs(i + (46 - roomy[room]) / 2, roomx[room] + (118 - roomx[room]) / 2);
      writechs(250, 0x74, 1);
      poscurs(i + (46 - roomy[room]) / 2, (118 - roomx[room]) / 2 + 2);
      writechs(roomchar[room], roomcol[room], roomx[room] - 2);
   }
   
   for(i = 1; i <= numdoors[room]; i++)
   {   
      poscurs(doory[room][i] + (46 - roomy[room]) / 2, doorx[room][i] + (118 - roomx[room]) / 2);
      switch(doortype[room][i])
      {
         case 1:
            writechs(doorchar[room][i], 0x06, 1);
            break;
         case 2:
            writechs(doorchar[room][i], 0x08, 1);
            break;
         case 3:
            writechs(doorchar[room][i], 0x0e, 1);
            break;
         case 4:
            writechs(doorchar[room][i], 0x76, 1);
            break;
         case 5:
            writechs(doorchar[room][i], 0x78, 1);
            break;
         case 6:
            writechs(doorchar[room][i], 0x08, 1);
            break;
         case 7:
            writechs(doorchar[room][i], 0x04, 1);
      }
   }
   poscurs((46 - roomy[room]) / 2 + heroy, (118 - roomx[room]) / 2 + herox);
   writechs(2, 0x0f, 1);
   
   for(i = 1; i <= numobj[room]; i++)
   {
      poscurs((46 - roomy[room]) / 2 + objy[room][i], (118 - roomx[room]) / 2 + objx[room][i]);
      writechs(objchar[room][i], objcol[room][i], 1);
   }
   
   for(i = 1; i <= numitm[room]; i++)
   {
      poscurs((46 - roomy[room]) / 2 + itmy[room][i], (118 - roomx[room]) / 2 + itmx[room][i]);
      writechs(itmchar[itmtype[room][i]], itmcol[itmtype[room][i]], 1);
   }
   
   for(i = 1; i <= nummons[room]; i++)
      if(monx[room][i] != 0)
      {
         poscurs((46 - roomy[room]) / 2 + mony[room][i], (118 - roomx[room]) / 2 + monx[room][i]);
         writechs(monchar[montype[room][i]], 0x04, 1);
      }
/*
   rnd = drand(100);
   
   if(rnd > 90)
      rndmon = 3;
   else if(rnd > 70)
      rndmon = 2;
   else if(rnd > 40)
      rndmon = 1;

   for(i = 1; i <= rndmon; i++)
   {
      while(notalone)
      {
         x = drand(roomx[room] - 2) + 1;
         y = drand(roomy[room] - 2) + 1;
         for(a = 1; a <=
*/
   newroom = 0;
}

door(x, y, doornum)
int x, y, doornum;
{
   int i, doorkey = 0;
   
   poscurs(textline,1); printf("%s", doortext[room][doornum]);
   inctl(1);
   
   if(doortype[room][doornum] == 3)
   {   
      for(i = 1; i <= numinv; i++)
         if(inv[1][i] == 16)
            doorkey = 1;
   }
   else if(doortype[room][doornum] == 6)
   {   
      for(i = 1; i <= numinv; i++)
         if(inv[1][i] == 20)
            doorkey = 2;
   }
   else if(doortype[room][doornum] == 7)
   {   
      for(i = 1; i <= numinv; i++)
         if(inv[1][i] == 15)
            doorkey = 1;
   }
   else
      doorkey = 1;

   if(doorkey == 1)
   {
      herox = newx[room][doornum]; heroy = newy[room][doornum];
      oldx = herox; oldy = heroy;
      room = doorexit[room][doornum];
      newroom = 1;
   }
   if(doorkey == 2)
      wingame = 1;
}      

movehero()
{
   int i;
   switch(key)
   {
      case 59:
         showinv();
         break;
      case 60:
         dropitm();
         break;
      case 61:
         useitm();
         break;
      case 62:
         showmon();
         break;
      case 71:
         --herox; --heroy;
         break;
      case 72:
         --heroy;
         break;
      case 73:
         ++herox; --heroy;
         break;
      case 75:
         --herox;
         break;
      case 77:
         ++herox;
         break;
      case 79:
         --herox; ++heroy;
         break;
      case 80:
         ++heroy;
         break;
      case 81:
         ++herox; ++heroy;
   }

   for(i = 1; i <= numdoors[room]; i++)
      if(herox == doorx[room][i] && heroy == doory[room][i])
         door(herox, heroy, i);

   if(herox == roomx[room])
      --herox;
   else if(herox == 1)
      ++herox;
   if(heroy == roomy[room])
      --heroy;
   else if(heroy == 1)
      ++heroy;
   
   for(i = 1; i <= nummons[room]; i++)
      if(herox == (int)monx[room][i] && heroy == (int)mony[room][i])
      {
         herox = oldx;
         heroy = oldy;
         heroattack(i);
      }
   
   for(i = 1; i <= numobj[room]; i++)
      if(herox == objx[room][i] && heroy == objy[room][i])
      {
         herox = oldx;
         heroy = oldy;
      }
   
   for(i = 1; i <= numitm[room]; i++)
      if(herox == itmx[room][i] && heroy == itmy[room][i])
      {
         herox = oldx;
         heroy = oldy;
         founditem(i);
      }

   if(herox != oldx || heroy != oldy)
   {
      poscurs((46 - roomy[room]) / 2 + oldy, (118 - roomx[room]) / 2 + oldx);
      writechs(roomchar[room], roomcol[room], 1);
   }
}

heroattack(mon)
int mon;                                             
{
   int damage, strike;
   
   strike = drand(mdefense[montype[room][mon]] + attack + attbon);
   if(strike > mdefense[montype[room][mon]])
   {  
      damage = strike - mdefense[montype[room][mon]];
      mhealth[room][mon] -= damage;
      
      poscurs(textline, 1);
      printf("hit the %c[32m%s", 27, montext[montype[room][mon]]);
      rsttxt();
      poscurs(textline, strlen(montext[montype[room][mon]]) + 9);
      printf("for %c[32m%d %c[37mdamage", 27, damage, 27);
      inctl(1);
      
      if(mhealth[room][mon] <= 0)
      {   
         monx[room][mon] = 0; mony[room][mon] = 0;
         poscurs(textline, 1);
         printf("%c[1m%c[37myou have slain the %c[32m%s", 27, 27, 27, montext[montype[room][mon]]);
         inctl(1);
         
         exp += monexp[montype[room][mon]];

         if(monitem[room][mon])
         {
            itmtype[room][++numitm[room]] = monitem[room][mon];

            itmx[room][numitm[room]] = oldmx[room][mon];
            itmy[room][numitm[room]] = oldmy[room][mon];
            
            poscurs((46 - roomy[room]) / 2 + itmy[room][numitm[room]], (118 - roomx[room]) / 2 + itmx[room][numitm[room]]);
            writechs(itmchar[itmtype[room][numitm[room]]], itmcol[itmtype[room][numitm[room]]], 1);
         }
      }
   }
}

founditem(item)
int item;
{
   int i;
   char choice;

   poscurs(textline, 1);
   printf("you found: %c[1m%c[37m%s", 27, 27, itmtext[itmtype[room][item]]);
   poscurs(textline + 1, 1);
   
   if(numinv < 5)
   {
      printf("%c[1m%c[37m   <P>%c[0m%c[37mick it up?", 27, 27, 27, 27);
      choice = getch();
      if(choice == 'p' || choice == 'P')
      {
         if(itmclass[itmtype[room][item]] == 4)
            gold += itmbonus[itmtype[room][item]];
         else
         {
            ++numinv;         

            inv[1][numinv] = itmtype[room][item];
            inv[2][numinv] = itmclass[itmtype[room][item]];
         }   
         poscurs((46 - roomy[room]) / 2 + itmy[room][item], (118 - roomx[room]) / 2 + itmx[room][item]);
         writechs(roomchar[room], roomcol[room], 1);

         if(item == numitm[room])
            --numitm[room];
         else
         {   
            for(i = item; i <= numitm[room]; i++)
            {
               itmx[room][i] = itmx[room][i + 1];
               itmy[room][i] = itmy[room][i + 1];
               itmtype[room][i] = itmtype[room][i + 1];
            }
            --numitm[room];
         }
      }
      cls(1, textline, 37, textline + 1); 
   }
}

dropitm()
{
   int i, choice = 0;
   char *prompt = "select item to drop";
   
   choice = menu(prompt);
   
   if(choice <= numinv && itmclass[inv[1][choice]] != 5 && itmclass[inv[1][choice]] != 7)
   {
      if(choice == numinv)
         --numinv;
      else
      {   
         for(i = choice; i <= numinv; i++)
         {
            inv[1][i] = inv[1][i + 1];
            inv[2][i] = inv[2][i + 1];
         }
         --numinv;
      }
   }
}

useitm()
{
   int i, choice = 0;
   char *prompt = "select item to use";
   
   choice = menu(prompt);
   
   if(choice <= numinv && itmclass[inv[1][choice]] != 5 && itmclass[inv[1][choice]] != 7)
   {
      switch(inv[2][choice])
      {
         case 1:
            shebon = itmbonus[inv[1][choice]];
            shield = itmtext[inv[1][choice]];
            break;
         case 2:
            armbon = itmbonus[inv[1][choice]];
            armour = itmtext[inv[1][choice]];
            break;
         case 3:
            attbon = itmbonus[inv[1][choice]];
            weapon = itmtext[inv[1][choice]];
            break;
         case 6:
            health += itmbonus[inv[1][choice]];
            if(health > maxhealth)
               health = maxhealth;
      }

      if(choice == numinv)
         --numinv;
      else
      {   
         for(i = choice; i <= numinv; i++)
         {
            inv[1][i] = inv[1][i + 1];
            inv[2][i] = inv[2][i + 1];
         }
         --numinv;
      }
      poscurs(2, 0);
      writechs(' ', 0x10, 79);
   }
}

menu(prompt)
char *prompt;
{
   int i, choice = 0, curspos = 1;
   
   cls(1, 5, 37, 44);
   
   poscurs(numinv + 7, 1);
   printf("%s", prompt);

   while(choice == 0)   
   {   
      for(i = 1; i <= numinv + 1; i++)
      {
         printf("%c[0m%c[1m%c[37m", 27, 27, 27);
         poscurs(i + 4, 1);
         if(i == curspos)
            printf("%c[7m", 27);
         if(i == numinv + 1)
            printf("cancel");
         else
            printf("%s", itmtext[inv[1][i]]);
      }
      
      switch(getch())
      {
         case 72:
            --curspos;
            if(curspos < 1)
               curspos = numinv + 1;
            break;
         case 80:
            ++curspos;
            if(curspos > numinv + 1)
               curspos = 1;
            break;
         case 13:
            choice = curspos;
      }
   }
   cls(1, 5, 37, 44);
   textline = 5;
   return(choice);
}

movemon()
{
   int i, j;
   for(i = 1; i <= nummons[room]; i++)
   {
      if(monx[room][i] != 0)
      {   
         if(monx[room][i] < herox)
            if(monx[room][i] + mspeed[montype[room][i]] > herox)
               monx[room][i] = herox;
            else
               monx[room][i] += mspeed[montype[room][i]];
         else if(monx[room][i] > herox)
            if(monx[room][i] - mspeed[montype[room][i]] < herox)
               monx[room][i] = herox;
            else
               monx[room][i] -= mspeed[montype[room][i]];
         if(mony[room][i] < heroy)
            if(mony[room][i] + mspeed[montype[room][i]] > heroy)
               mony[room][i] = heroy;
            else
               mony[room][i] += mspeed[montype[room][i]];
         else if(mony[room][i] > heroy)
            if(mony[room][i] - mspeed[montype[room][i]] < heroy)
               mony[room][i] = heroy;
            else
               mony[room][i] -= mspeed[montype[room][i]];
         
         if((int)monx[room][i] == herox && (int)mony[room][i] == heroy)
         {
            monx[room][i] = oldmx[room][i];
            mony[room][i] = oldmy[room][i];
            monattack(i);
         }
         
         for(j = 1; j <= nummons[room]; j++)
            if((int)monx[room][i] == (int)monx[room][j] && (int)mony[room][i] == (int)mony[room][j] && i != j)
            {
               monx[room][i] = oldmx[room][i];
               mony[room][i] = oldmy[room][i];
            }
         
         for(j = 1; j <= numobj[room]; j++)
            if((int)monx[room][i] == objx[room][j] && (int)mony[room][i] == objy[room][j])
            {
               monx[room][i] = oldmx[room][i];
               mony[room][i] = oldmy[room][i];
            }
         
         for(j = 1; j <= numitm[room]; j++)
            if((int)monx[room][i] == itmx[room][j] && (int)mony[room][i] == itmy[room][j])
            {
               monx[room][i] = oldmx[room][i];
               mony[room][i] = oldmy[room][i];
            }
         
         poscurs((46 - roomy[room]) / 2 + oldmy[room][i], (118 - roomx[room]) / 2 + oldmx[room][i]);
         writechs(roomchar[room], roomcol[room], 1);
         oldmx[room][i] = monx[room][i]; oldmy[room][i] = mony[room][i];
      }
   }
}
                                    
monattack(mon)
int mon;                                             
{
   int damage, strike;
   
   strike = drand(defense + armbon + shebon + mattack[montype[room][mon]]);
   if(strike > defense + armbon + shebon)
   {  
      damage = strike - defense - armbon - shebon;
      health -= damage;
      
      poscurs(textline, 1);
      printf("%c[31m%s", 27, montext[montype[room][mon]]);
      rsttxt();
      poscurs(textline, strlen(montext[montype[room][mon]]) + 1);
      printf("hit you for %c[31m%d%c[37m damage", 27, damage, 27);
      inctl(1);
   }
}

drawstuff()
{
   int i;
   poscurs((46 - roomy[room]) / 2 + heroy, (118 - roomx[room]) / 2 + herox);
   writechs(2, 0x0f, 1);
   for(i = 1; i <= nummons[room]; i++)
      if(monx[room][i] != 0)
      {
         poscurs((46 - roomy[room]) / 2 + mony[room][i], (118 - roomx[room]) / 2 + monx[room][i]);
         writechs(monchar[montype[room][i]], mcol[montype[room][i]], 1);
      }
}

showinv()
{
   int i;

   cls(1, 5, 37, 44);
   for(i = 1; i <= numinv; i++)
   {
      poscurs(i + 4, 1);
      printf("%c[1m%c[37m%s", 27, 27, itmtext[inv[1][i]]);
      rsttxt();
      textline = 6 + numinv;
   }
}

showmon()
{
   int i;
   cls(1, 5, 37, 44);
   for(i = 1; i < 14; i++)
   {
      poscurs(i + 4, 1);
      writechs(monchar[i], mcol[i], 1);
      poscurs(i + 4, 3);
      printf("%s", montext[i]);
   }
   for(i = 1; i < 21; i++)
   {
      poscurs(i + 18, 1);
      writechs(itmchar[i], itmcol[i], 1);
      poscurs(i + 18, 3);
      printf("%s", itmtext[i]);
   }
   textline = 40;
}

cls(x1, y1, x2, y2)
int x1, y1, x2, y2;
{
   int i;
   for(i = y1; i <= y2; i++)
   {
      poscurs(i, x1);
      writechs(' ', 0x00, x2-x1);
   }
}

inctl(a)
int a;
{
   rsttxt();
   textline += a;
   
   if(textline >= 44)
   {   
      textline = 5;
      clrlines = 5;
   }
   
   else if(textline >= 39)
      clrlines = 44 - textline;
      
   cls(1, textline, 37, textline + clrlines);
}

rsttxt()
{
   printf("%c[40m%c[0m%c[37m", 27, 27, 27);
}
